﻿function ChangeValueControlType(onLoad) {
    let typeSelectValue = $("#Data_Type option:selected").text();

    let valueControl = $("#Data_Value");
    if (!onLoad) {
        valueControl.val("");
    }

    let authControl = $('#authBlock');

    let valueTextEditGroupControl = $("#valueTextEditGroup");
    let valueCheckboxGroupControl = $("#valueCheckboxGroup");

    if (typeSelectValue == "Text") {
        valueControl.attr("type", "text");
        valueControl.removeAttr("placeholder");
         valueControl.show();
        valueTextEditGroupControl.show();
        valueCheckboxGroupControl.hide();
        authControl.hide();
    }
    else if (typeSelectValue == "Int") {
        valueControl.attr("type", "number");
        valueControl.removeAttr("placeholder");
        valueControl.show();

        valueTextEditGroupControl.show();
        valueCheckboxGroupControl.hide();
        authControl.hide();
    }
    else if (typeSelectValue == "Bool") {
        valueControl.attr("type", "hidden");

        valueTextEditGroupControl.hide();
        valueCheckboxGroupControl.show();
        authControl.hide();

        valueCheckboxVal = $("#valueCheckbox").prop("checked");
        valueControl.val(valueCheckboxVal);
    }

    else if (typeSelectValue == "SecureData") {
        valueControl.val("");
        valueControl.attr("type", "password");
        valueControl.show();
        valueTextEditGroupControl.show();
        valueCheckboxGroupControl.hide();
        authControl.hide();
    }

    else if (typeSelectValue == "AuthCredential") {
        valueControl.attr("type", "hidden");
        valueTextEditGroupControl.hide();
        valueCheckboxGroupControl.hide();
        authControl.show();
    }
}