﻿let GetQueueElementBlockContentHandler = {

    initializeGetQueueElementModal: function () {

        this.initializeBlockFooter();

        let getQueueElementPropertiesElement = document.getElementById("getQueueElementProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(getQueueElementPropertiesElement);
        getQueueElementPropertiesElement.style.display = "block";

        if (selectedBlock.userData) {
            let queueNameInputElement = getQueueElementPropertiesElement.querySelector("[data-purpose=queueName]");
            let statusSelect = getQueueElementPropertiesElement.querySelector("[data-purpose=queueElementStatusAfterReceiving]");
            let referenceInput = getQueueElementPropertiesElement.querySelector("[data-purpose=reference]");
            let priorityInput = getQueueElementPropertiesElement.querySelector("[data-purpose=priority]");
            let commentInput = getQueueElementPropertiesElement.querySelector("[data-purpose=comment]");

            if (selectedBlock.userData.queueName)
                queueNameInputElement.value = selectedBlock.userData.queueName;
            else
                queueNameInputElement.selectedIndex = 0;

            if (selectedBlock.userData.queueElementStatusAfterReceiving)
                statusSelect.value = selectedBlock.userData.queueElementStatusAfterReceiving;
            else
                statusSelect.value = null;

            if (selectedBlock.userData.reference)
                referenceInput.value = selectedBlock.userData.reference;
            else
                referenceInput.value = null;

            if (selectedBlock.userData.priority)
                priorityInput.value = selectedBlock.userData.priority;
            else
                priorityInput.selectedIndex = 0;

            if (selectedBlock.userData.comment)
                commentInput.value = selectedBlock.userData.comment;
            else
                commentInput.value = null;
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            GetQueueElementBlockContentHandler.saveQueueNameProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveQueueNameProperties: function () {
        let getQueueElementPropertiesElement = document.getElementById("getQueueElementProperties");
        let queueNameElement = getQueueElementPropertiesElement.querySelector("[data-purpose=queueName]");
        let statusAfterReceivingElement = getQueueElementPropertiesElement.querySelector("[data-purpose=queueElementStatusAfterReceiving]");
        let referenceElement = getQueueElementPropertiesElement.querySelector("[data-purpose=reference]");
        let priorityInput = getQueueElementPropertiesElement.querySelector("[data-purpose=priority]");
        let commentInput = getQueueElementPropertiesElement.querySelector("[data-purpose=comment]");

        selectedBlock.userData.queueName = queueNameElement.value;
        selectedBlock.userData.queueElementStatusAfterReceiving = statusAfterReceivingElement.value;
        selectedBlock.userData.blockName = blockNameInputElement.value;
        selectedBlock.userData.reference = referenceElement.value;
        selectedBlock.userData.priority = priorityInput.value;
        selectedBlock.userData.comment = commentInput.value;

        setBlockNameLabel(selectedBlock, "getQueueElementName", blockNameInputElement.value);
    }

}