﻿let GetKafkaMessageBlockContentHandler = {

    initializeGetKafkaMessageModal: function () {

        this.initializeBlockFooter();

        let getKafkaMessagePropertiesElement = document.getElementById("getKafkaMessageProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(getKafkaMessagePropertiesElement);
        getKafkaMessagePropertiesElement.style.display = "block";

        if (selectedBlock.userData) {
            if (selectedBlock.userData.bootstrapServers) {
                let bootstrapServersInputElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=bootstrapServers]");
                bootstrapServersInputElement.value = selectedBlock.userData.bootstrapServers;
            }

            if (selectedBlock.userData.groupId) {
                let groupIdElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=groupId]");
                groupIdElement.value = selectedBlock.userData.groupId;
            }

            if (selectedBlock.userData.topic) {
                let topicElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=topic]");
                topicElement.value = selectedBlock.userData.topic;
            }
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            GetKafkaMessageBlockContentHandler.saveGetKafkaMessageProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveGetKafkaMessageProperties: function () {
        let getKafkaMessagePropertiesElement = document.getElementById("getKafkaMessageProperties");

        let bootstrapServersInputElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=bootstrapServers]");
        let groupIdElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=groupId]");
        let topicElement = getKafkaMessagePropertiesElement.querySelector("[data-purpose=topic]");

        selectedBlock.userData.bootstrapServers = bootstrapServersInputElement.value;
        selectedBlock.userData.groupId = groupIdElement.value;
        selectedBlock.userData.topic = topicElement.value;
        selectedBlock.userData.blockName = blockNameInputElement.value;

        setBlockNameLabel(selectedBlock, "blockName", blockNameInputElement.value);
    }
}